<?php

namespace room;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Auth' => '\\room\\StructType\\Auth',
            'FromSystemId' => '\\room\\StructType\\FromSystemId',
            'GetAvailabilityRQ' => '\\room\\StructType\\GetAvailabilityRQ',
            'PromotionalCode' => '\\room\\StructType\\PromotionalCode',
            'GetAvailabilityRS' => '\\room\\StructType\\GetAvailabilityRS',
            'GetCompanyAccountRQ' => '\\room\\StructType\\GetCompanyAccountRQ',
            'GetCompanyAccountRS' => '\\room\\StructType\\GetCompanyAccountRS',
            'GetCountriesRQ' => '\\room\\StructType\\GetCountriesRQ',
            'GetCountriesRS' => '\\room\\StructType\\GetCountriesRS',
            'GetHotelDetailsRQ' => '\\room\\StructType\\GetHotelDetailsRQ',
            'GetHotelDetailsRS' => '\\room\\StructType\\GetHotelDetailsRS',
            'GetHotelsRQ' => '\\room\\StructType\\GetHotelsRQ',
            'GetHotelsRS' => '\\room\\StructType\\GetHotelsRS',
            'GetLosRulesRQ' => '\\room\\StructType\\GetLosRulesRQ',
            'GetLosRulesRS' => '\\room\\StructType\\GetLosRulesRS',
            'GetObmConfigRQ' => '\\room\\StructType\\GetObmConfigRQ',
            'GetObmConfigRS' => '\\room\\StructType\\GetObmConfigRS',
            'GetProfileRQ' => '\\room\\StructType\\GetProfileRQ',
            'GetProfileRS' => '\\room\\StructType\\GetProfileRS',
            'GetProfileV2RQ' => '\\room\\StructType\\GetProfileV2RQ',
            'GetProfileV2RS' => '\\room\\StructType\\GetProfileV2RS',
            'GetRatesRQ' => '\\room\\StructType\\GetRatesRQ',
            'GetRatesRS' => '\\room\\StructType\\GetRatesRS',
            'GetRegionsRQ' => '\\room\\StructType\\GetRegionsRQ',
            'GetRegionsRS' => '\\room\\StructType\\GetRegionsRS',
            'GetReservationRQ' => '\\room\\StructType\\GetReservationRQ',
            'GetReservationRS' => '\\room\\StructType\\GetReservationRS',
            'GetRoomsRQ' => '\\room\\StructType\\GetRoomsRQ',
            'GetRoomsRS' => '\\room\\StructType\\GetRoomsRS',
            'GetUpsellsRQ' => '\\room\\StructType\\GetUpsellsRQ',
            'GetUpsellsRS' => '\\room\\StructType\\GetUpsellsRS',
            'MakeProfileRQ' => '\\room\\StructType\\MakeProfileRQ',
            'MakeProfileRS' => '\\room\\StructType\\MakeProfileRS',
            'MakeReservationRQ' => '\\room\\StructType\\MakeReservationRQ',
            'MakeReservationRS' => '\\room\\StructType\\MakeReservationRS',
            'SendProfilePasswordRQ' => '\\room\\StructType\\SendProfilePasswordRQ',
            'SendProfilePasswordRS' => '\\room\\StructType\\SendProfilePasswordRS',
            'ResponseType' => '\\room\\StructType\\ResponseType',
            'CountriesType' => '\\room\\StructType\\CountriesType',
            'CountryType' => '\\room\\StructType\\CountryType',
            'DebugInfoType' => '\\room\\StructType\\DebugInfoType',
            'WarningsType' => '\\room\\StructType\\WarningsType',
            'WarningType' => '\\room\\StructType\\WarningType',
            'ErrorsType' => '\\room\\StructType\\ErrorsType',
            'ErrorType' => '\\room\\StructType\\ErrorType',
            'HotelRefType' => '\\room\\StructType\\HotelRefType',
            'RoomsType' => '\\room\\StructType\\RoomsType',
            'RoomType' => '\\room\\StructType\\RoomType',
            'Occupants' => '\\room\\StructType\\Occupants',
            'DescriptionType' => '\\room\\StructType\\DescriptionType',
            'DescriptionsType' => '\\room\\StructType\\DescriptionsType',
            'FeaturesType' => '\\room\\StructType\\FeaturesType',
            'FeatureType' => '\\room\\StructType\\FeatureType',
            'RoomImagesType' => '\\room\\StructType\\RoomImagesType',
            'RoomImageType' => '\\room\\StructType\\RoomImageType',
            'UpsellsType' => '\\room\\StructType\\UpsellsType',
            'UpsellType' => '\\room\\StructType\\UpsellType',
            'ChargeModeType' => '\\room\\StructType\\ChargeModeType',
            'PostingModesType' => '\\room\\StructType\\PostingModesType',
            'PostingModeType' => '\\room\\StructType\\PostingModeType',
            'DailyAvailabilitiesType' => '\\room\\StructType\\DailyAvailabilitiesType',
            'AvailabilityType' => '\\room\\StructType\\AvailabilityType',
            'RestrictionsType' => '\\room\\StructType\\RestrictionsType',
            'RestrictionType' => '\\room\\StructType\\RestrictionType',
            'WholeStayDiscountsLosRulesType' => '\\room\\StructType\\WholeStayDiscountsLosRulesType',
            'WholeStayDiscountsLosRuleType' => '\\room\\StructType\\WholeStayDiscountsLosRuleType',
            'FreeNightsLosRulesType' => '\\room\\StructType\\FreeNightsLosRulesType',
            'FreeNightsLosRuleType' => '\\room\\StructType\\FreeNightsLosRuleType',
            'ProfileType' => '\\room\\StructType\\ProfileType',
            'AddressType' => '\\room\\StructType\\AddressType',
            'ContactDetailsType' => '\\room\\StructType\\ContactDetailsType',
            'TelephoneNumbersType' => '\\room\\StructType\\TelephoneNumbersType',
            'CompanyType' => '\\room\\StructType\\CompanyType',
            'Attributes' => '\\room\\StructType\\Attributes',
            'AttributeType' => '\\room\\StructType\\AttributeType',
            'AccessCodeItem' => '\\room\\StructType\\AccessCodeItem',
            'HotelDetailsType' => '\\room\\StructType\\HotelDetailsType',
            'RatingType' => '\\room\\StructType\\RatingType',
            'PositionType' => '\\room\\StructType\\PositionType',
            'RulesType' => '\\room\\StructType\\RulesType',
            'CancellationPoliciesType' => '\\room\\StructType\\CancellationPoliciesType',
            'CancellationPolicyType' => '\\room\\StructType\\CancellationPolicyType',
            'PenaltyType' => '\\room\\StructType\\PenaltyType',
            'MealsType' => '\\room\\StructType\\MealsType',
            'Meal' => '\\room\\StructType\\Meal',
            'HotelImagesType' => '\\room\\StructType\\HotelImagesType',
            'ImageType' => '\\room\\StructType\\ImageType',
            'HotelsType' => '\\room\\StructType\\HotelsType',
            'HotelType' => '\\room\\StructType\\HotelType',
            'BestPriceAvailabilityType' => '\\room\\StructType\\BestPriceAvailabilityType',
            'AvailableRoomRatesType' => '\\room\\StructType\\AvailableRoomRatesType',
            'AvailableRoomRateType' => '\\room\\StructType\\AvailableRoomRateType',
            'RatesType' => '\\room\\StructType\\RatesType',
            'RateType' => '\\room\\StructType\\RateType',
            'BaseType' => '\\room\\StructType\\BaseType',
            'RatePlansType' => '\\room\\StructType\\RatePlansType',
            'RatePlanType' => '\\room\\StructType\\RatePlanType',
            'PrePaymentType' => '\\room\\StructType\\PrePaymentType',
            'RegionsType' => '\\room\\StructType\\RegionsType',
            'RegionType' => '\\room\\StructType\\RegionType',
            'ObmConfigsType' => '\\room\\StructType\\ObmConfigsType',
            'ObmConfigType' => '\\room\\StructType\\ObmConfigType',
            'ReservationType' => '\\room\\StructType\\ReservationType',
            'BookerRPH' => '\\room\\StructType\\BookerRPH',
            'RoomStaysType' => '\\room\\StructType\\RoomStaysType',
            'RoomStayType' => '\\room\\StructType\\RoomStayType',
            'RoomRatesType' => '\\room\\StructType\\RoomRatesType',
            'RoomRateType' => '\\room\\StructType\\RoomRateType',
            'GuestCountsType' => '\\room\\StructType\\GuestCountsType',
            'GuestCountType' => '\\room\\StructType\\GuestCountType',
            'TotalType' => '\\room\\StructType\\TotalType',
            'ResGuestRPHsType' => '\\room\\StructType\\ResGuestRPHsType',
            'ResGuestRPH' => '\\room\\StructType\\ResGuestRPH',
            'DepositType' => '\\room\\StructType\\DepositType',
            'ResDiaryReferencesType' => '\\room\\StructType\\ResDiaryReferencesType',
            'ResDiaryReferenceType' => '\\room\\StructType\\ResDiaryReferenceType',
            'ProfilesType' => '\\room\\StructType\\ProfilesType',
            'GuaranteeType' => '\\room\\StructType\\GuaranteeType',
            'CreditCardType' => '\\room\\StructType\\CreditCardType',
            'AuthorisationProviderType' => '\\room\\StructType\\AuthorisationProviderType',
            'LedgerCompanyRefType' => '\\room\\StructType\\LedgerCompanyRefType',
            'TicketItemType' => '\\room\\StructType\\TicketItemType',
            'DCCType' => '\\room\\StructType\\DCCType',
            'HotelListType' => '\\room\\StructType\\HotelListType',
            'LocationFilterType' => '\\room\\StructType\\LocationFilterType',
            'Destination' => '\\room\\StructType\\Destination',
            'StayDetailsType' => '\\room\\StructType\\StayDetailsType',
            'StayDateRangeType' => '\\room\\StructType\\StayDateRangeType',
            'RatePlanCodesType' => '\\room\\StructType\\RatePlanCodesType',
            'RoomCodesType' => '\\room\\StructType\\RoomCodesType',
            'CompanyRefType' => '\\room\\StructType\\CompanyRefType',
            'CountiesType' => '\\room\\StructType\\CountiesType',
        );
    }
}
