<?php

namespace room\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AvailableRoomRatesType StructType
 * @subpackage Structs
 */
class AvailableRoomRatesType extends AbstractStructBase
{
    /**
     * The AvailableRoomRate
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \room\StructType\AvailableRoomRateType[]
     */
    public $AvailableRoomRate;
    /**
     * Constructor method for AvailableRoomRatesType
     * @uses AvailableRoomRatesType::setAvailableRoomRate()
     * @param \room\StructType\AvailableRoomRateType[] $availableRoomRate
     */
    public function __construct(array $availableRoomRate = array())
    {
        $this
            ->setAvailableRoomRate($availableRoomRate);
    }
    /**
     * Get AvailableRoomRate value
     * @return \room\StructType\AvailableRoomRateType[]|null
     */
    public function getAvailableRoomRate()
    {
        return $this->AvailableRoomRate;
    }
    /**
     * This method is responsible for validating the values passed to the setAvailableRoomRate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAvailableRoomRate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAvailableRoomRateForArrayConstraintsFromSetAvailableRoomRate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $availableRoomRatesTypeAvailableRoomRateItem) {
            // validation for constraint: itemType
            if (!$availableRoomRatesTypeAvailableRoomRateItem instanceof \room\StructType\AvailableRoomRateType) {
                $invalidValues[] = is_object($availableRoomRatesTypeAvailableRoomRateItem) ? get_class($availableRoomRatesTypeAvailableRoomRateItem) : sprintf('%s(%s)', gettype($availableRoomRatesTypeAvailableRoomRateItem), var_export($availableRoomRatesTypeAvailableRoomRateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AvailableRoomRate property can only contain items of type \room\StructType\AvailableRoomRateType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AvailableRoomRate value
     * @throws \InvalidArgumentException
     * @param \room\StructType\AvailableRoomRateType[] $availableRoomRate
     * @return \room\StructType\AvailableRoomRatesType
     */
    public function setAvailableRoomRate(array $availableRoomRate = array())
    {
        // validation for constraint: array
        if ('' !== ($availableRoomRateArrayErrorMessage = self::validateAvailableRoomRateForArrayConstraintsFromSetAvailableRoomRate($availableRoomRate))) {
            throw new \InvalidArgumentException($availableRoomRateArrayErrorMessage, __LINE__);
        }
        $this->AvailableRoomRate = $availableRoomRate;
        return $this;
    }
    /**
     * Add item to AvailableRoomRate value
     * @throws \InvalidArgumentException
     * @param \room\StructType\AvailableRoomRateType $item
     * @return \room\StructType\AvailableRoomRatesType
     */
    public function addToAvailableRoomRate(\room\StructType\AvailableRoomRateType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \room\StructType\AvailableRoomRateType) {
            throw new \InvalidArgumentException(sprintf('The AvailableRoomRate property can only contain items of type \room\StructType\AvailableRoomRateType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AvailableRoomRate[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \room\StructType\AvailableRoomRatesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
