<?php

namespace room\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CancellationPoliciesType StructType
 * @subpackage Structs
 */
class CancellationPoliciesType extends AbstractStructBase
{
    /**
     * The CancellationPolicy
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \room\StructType\CancellationPolicyType[]
     */
    public $CancellationPolicy;
    /**
     * Constructor method for CancellationPoliciesType
     * @uses CancellationPoliciesType::setCancellationPolicy()
     * @param \room\StructType\CancellationPolicyType[] $cancellationPolicy
     */
    public function __construct(array $cancellationPolicy = array())
    {
        $this
            ->setCancellationPolicy($cancellationPolicy);
    }
    /**
     * Get CancellationPolicy value
     * @return \room\StructType\CancellationPolicyType[]|null
     */
    public function getCancellationPolicy()
    {
        return $this->CancellationPolicy;
    }
    /**
     * This method is responsible for validating the values passed to the setCancellationPolicy method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCancellationPolicy method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCancellationPolicyForArrayConstraintsFromSetCancellationPolicy(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $cancellationPoliciesTypeCancellationPolicyItem) {
            // validation for constraint: itemType
            if (!$cancellationPoliciesTypeCancellationPolicyItem instanceof \room\StructType\CancellationPolicyType) {
                $invalidValues[] = is_object($cancellationPoliciesTypeCancellationPolicyItem) ? get_class($cancellationPoliciesTypeCancellationPolicyItem) : sprintf('%s(%s)', gettype($cancellationPoliciesTypeCancellationPolicyItem), var_export($cancellationPoliciesTypeCancellationPolicyItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CancellationPolicy property can only contain items of type \room\StructType\CancellationPolicyType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CancellationPolicy value
     * @throws \InvalidArgumentException
     * @param \room\StructType\CancellationPolicyType[] $cancellationPolicy
     * @return \room\StructType\CancellationPoliciesType
     */
    public function setCancellationPolicy(array $cancellationPolicy = array())
    {
        // validation for constraint: array
        if ('' !== ($cancellationPolicyArrayErrorMessage = self::validateCancellationPolicyForArrayConstraintsFromSetCancellationPolicy($cancellationPolicy))) {
            throw new \InvalidArgumentException($cancellationPolicyArrayErrorMessage, __LINE__);
        }
        $this->CancellationPolicy = $cancellationPolicy;
        return $this;
    }
    /**
     * Add item to CancellationPolicy value
     * @throws \InvalidArgumentException
     * @param \room\StructType\CancellationPolicyType $item
     * @return \room\StructType\CancellationPoliciesType
     */
    public function addToCancellationPolicy(\room\StructType\CancellationPolicyType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \room\StructType\CancellationPolicyType) {
            throw new \InvalidArgumentException(sprintf('The CancellationPolicy property can only contain items of type \room\StructType\CancellationPolicyType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CancellationPolicy[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \room\StructType\CancellationPoliciesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
