<?php

namespace room\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DescriptionsType StructType
 * @subpackage Structs
 */
class DescriptionsType extends AbstractStructBase
{
    /**
     * The ShortDescription
     * @var \room\StructType\DescriptionType
     */
    public $ShortDescription;
    /**
     * The LongDescription
     * @var \room\StructType\DescriptionType
     */
    public $LongDescription;
    /**
     * The HighlightText
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \room\StructType\DescriptionType
     */
    public $HighlightText;
    /**
     * Constructor method for DescriptionsType
     * @uses DescriptionsType::setShortDescription()
     * @uses DescriptionsType::setLongDescription()
     * @uses DescriptionsType::setHighlightText()
     * @param \room\StructType\DescriptionType $shortDescription
     * @param \room\StructType\DescriptionType $longDescription
     * @param \room\StructType\DescriptionType $highlightText
     */
    public function __construct(\room\StructType\DescriptionType $shortDescription = null, \room\StructType\DescriptionType $longDescription = null, \room\StructType\DescriptionType $highlightText = null)
    {
        $this
            ->setShortDescription($shortDescription)
            ->setLongDescription($longDescription)
            ->setHighlightText($highlightText);
    }
    /**
     * Get ShortDescription value
     * @return \room\StructType\DescriptionType|null
     */
    public function getShortDescription()
    {
        return $this->ShortDescription;
    }
    /**
     * Set ShortDescription value
     * @param \room\StructType\DescriptionType $shortDescription
     * @return \room\StructType\DescriptionsType
     */
    public function setShortDescription(\room\StructType\DescriptionType $shortDescription = null)
    {
        $this->ShortDescription = $shortDescription;
        return $this;
    }
    /**
     * Get LongDescription value
     * @return \room\StructType\DescriptionType|null
     */
    public function getLongDescription()
    {
        return $this->LongDescription;
    }
    /**
     * Set LongDescription value
     * @param \room\StructType\DescriptionType $longDescription
     * @return \room\StructType\DescriptionsType
     */
    public function setLongDescription(\room\StructType\DescriptionType $longDescription = null)
    {
        $this->LongDescription = $longDescription;
        return $this;
    }
    /**
     * Get HighlightText value
     * @return \room\StructType\DescriptionType|null
     */
    public function getHighlightText()
    {
        return $this->HighlightText;
    }
    /**
     * Set HighlightText value
     * @param \room\StructType\DescriptionType $highlightText
     * @return \room\StructType\DescriptionsType
     */
    public function setHighlightText(\room\StructType\DescriptionType $highlightText = null)
    {
        $this->HighlightText = $highlightText;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \room\StructType\DescriptionsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
