<?php

namespace room\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FeaturesType StructType
 * @subpackage Structs
 */
class FeaturesType extends AbstractStructBase
{
    /**
     * The Feature
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \room\StructType\FeatureType[]
     */
    public $Feature;
    /**
     * Constructor method for FeaturesType
     * @uses FeaturesType::setFeature()
     * @param \room\StructType\FeatureType[] $feature
     */
    public function __construct(array $feature = array())
    {
        $this
            ->setFeature($feature);
    }
    /**
     * Get Feature value
     * @return \room\StructType\FeatureType[]|null
     */
    public function getFeature()
    {
        return $this->Feature;
    }
    /**
     * This method is responsible for validating the values passed to the setFeature method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFeature method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFeatureForArrayConstraintsFromSetFeature(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $featuresTypeFeatureItem) {
            // validation for constraint: itemType
            if (!$featuresTypeFeatureItem instanceof \room\StructType\FeatureType) {
                $invalidValues[] = is_object($featuresTypeFeatureItem) ? get_class($featuresTypeFeatureItem) : sprintf('%s(%s)', gettype($featuresTypeFeatureItem), var_export($featuresTypeFeatureItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Feature property can only contain items of type \room\StructType\FeatureType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Feature value
     * @throws \InvalidArgumentException
     * @param \room\StructType\FeatureType[] $feature
     * @return \room\StructType\FeaturesType
     */
    public function setFeature(array $feature = array())
    {
        // validation for constraint: array
        if ('' !== ($featureArrayErrorMessage = self::validateFeatureForArrayConstraintsFromSetFeature($feature))) {
            throw new \InvalidArgumentException($featureArrayErrorMessage, __LINE__);
        }
        $this->Feature = $feature;
        return $this;
    }
    /**
     * Add item to Feature value
     * @throws \InvalidArgumentException
     * @param \room\StructType\FeatureType $item
     * @return \room\StructType\FeaturesType
     */
    public function addToFeature(\room\StructType\FeatureType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \room\StructType\FeatureType) {
            throw new \InvalidArgumentException(sprintf('The Feature property can only contain items of type \room\StructType\FeatureType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Feature[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \room\StructType\FeaturesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
