<?php

namespace room\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FreeNightsLosRulesType StructType
 * @subpackage Structs
 */
class FreeNightsLosRulesType extends AbstractStructBase
{
    /**
     * The FreeNightsLosRule
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \room\StructType\FreeNightsLosRuleType[]
     */
    public $FreeNightsLosRule;
    /**
     * Constructor method for FreeNightsLosRulesType
     * @uses FreeNightsLosRulesType::setFreeNightsLosRule()
     * @param \room\StructType\FreeNightsLosRuleType[] $freeNightsLosRule
     */
    public function __construct(array $freeNightsLosRule = array())
    {
        $this
            ->setFreeNightsLosRule($freeNightsLosRule);
    }
    /**
     * Get FreeNightsLosRule value
     * @return \room\StructType\FreeNightsLosRuleType[]|null
     */
    public function getFreeNightsLosRule()
    {
        return $this->FreeNightsLosRule;
    }
    /**
     * This method is responsible for validating the values passed to the setFreeNightsLosRule method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFreeNightsLosRule method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFreeNightsLosRuleForArrayConstraintsFromSetFreeNightsLosRule(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $freeNightsLosRulesTypeFreeNightsLosRuleItem) {
            // validation for constraint: itemType
            if (!$freeNightsLosRulesTypeFreeNightsLosRuleItem instanceof \room\StructType\FreeNightsLosRuleType) {
                $invalidValues[] = is_object($freeNightsLosRulesTypeFreeNightsLosRuleItem) ? get_class($freeNightsLosRulesTypeFreeNightsLosRuleItem) : sprintf('%s(%s)', gettype($freeNightsLosRulesTypeFreeNightsLosRuleItem), var_export($freeNightsLosRulesTypeFreeNightsLosRuleItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FreeNightsLosRule property can only contain items of type \room\StructType\FreeNightsLosRuleType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FreeNightsLosRule value
     * @throws \InvalidArgumentException
     * @param \room\StructType\FreeNightsLosRuleType[] $freeNightsLosRule
     * @return \room\StructType\FreeNightsLosRulesType
     */
    public function setFreeNightsLosRule(array $freeNightsLosRule = array())
    {
        // validation for constraint: array
        if ('' !== ($freeNightsLosRuleArrayErrorMessage = self::validateFreeNightsLosRuleForArrayConstraintsFromSetFreeNightsLosRule($freeNightsLosRule))) {
            throw new \InvalidArgumentException($freeNightsLosRuleArrayErrorMessage, __LINE__);
        }
        $this->FreeNightsLosRule = $freeNightsLosRule;
        return $this;
    }
    /**
     * Add item to FreeNightsLosRule value
     * @throws \InvalidArgumentException
     * @param \room\StructType\FreeNightsLosRuleType $item
     * @return \room\StructType\FreeNightsLosRulesType
     */
    public function addToFreeNightsLosRule(\room\StructType\FreeNightsLosRuleType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \room\StructType\FreeNightsLosRuleType) {
            throw new \InvalidArgumentException(sprintf('The FreeNightsLosRule property can only contain items of type \room\StructType\FreeNightsLosRuleType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FreeNightsLosRule[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \room\StructType\FreeNightsLosRulesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
