<?php

namespace room\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GuaranteeType StructType
 * @subpackage Structs
 */
class GuaranteeType extends AbstractStructBase
{
    /**
     * The CreditCard
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \room\StructType\CreditCardType
     */
    public $CreditCard;
    /**
     * The LedgerCompanyRef
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \room\StructType\LedgerCompanyRefType
     */
    public $LedgerCompanyRef;
    /**
     * Constructor method for GuaranteeType
     * @uses GuaranteeType::setCreditCard()
     * @uses GuaranteeType::setLedgerCompanyRef()
     * @param \room\StructType\CreditCardType $creditCard
     * @param \room\StructType\LedgerCompanyRefType $ledgerCompanyRef
     */
    public function __construct(\room\StructType\CreditCardType $creditCard = null, \room\StructType\LedgerCompanyRefType $ledgerCompanyRef = null)
    {
        $this
            ->setCreditCard($creditCard)
            ->setLedgerCompanyRef($ledgerCompanyRef);
    }
    /**
     * Get CreditCard value
     * @return \room\StructType\CreditCardType|null
     */
    public function getCreditCard()
    {
        return $this->CreditCard;
    }
    /**
     * Set CreditCard value
     * @param \room\StructType\CreditCardType $creditCard
     * @return \room\StructType\GuaranteeType
     */
    public function setCreditCard(\room\StructType\CreditCardType $creditCard = null)
    {
        $this->CreditCard = $creditCard;
        return $this;
    }
    /**
     * Get LedgerCompanyRef value
     * @return \room\StructType\LedgerCompanyRefType|null
     */
    public function getLedgerCompanyRef()
    {
        return $this->LedgerCompanyRef;
    }
    /**
     * Set LedgerCompanyRef value
     * @param \room\StructType\LedgerCompanyRefType $ledgerCompanyRef
     * @return \room\StructType\GuaranteeType
     */
    public function setLedgerCompanyRef(\room\StructType\LedgerCompanyRefType $ledgerCompanyRef = null)
    {
        $this->LedgerCompanyRef = $ledgerCompanyRef;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \room\StructType\GuaranteeType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
