<?php

namespace room\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GuestCountsType StructType
 * @subpackage Structs
 */
class GuestCountsType extends AbstractStructBase
{
    /**
     * The GuestCount
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \room\StructType\GuestCountType[]
     */
    public $GuestCount;
    /**
     * Constructor method for GuestCountsType
     * @uses GuestCountsType::setGuestCount()
     * @param \room\StructType\GuestCountType[] $guestCount
     */
    public function __construct(array $guestCount = array())
    {
        $this
            ->setGuestCount($guestCount);
    }
    /**
     * Get GuestCount value
     * @return \room\StructType\GuestCountType[]|null
     */
    public function getGuestCount()
    {
        return $this->GuestCount;
    }
    /**
     * This method is responsible for validating the values passed to the setGuestCount method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGuestCount method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGuestCountForArrayConstraintsFromSetGuestCount(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $guestCountsTypeGuestCountItem) {
            // validation for constraint: itemType
            if (!$guestCountsTypeGuestCountItem instanceof \room\StructType\GuestCountType) {
                $invalidValues[] = is_object($guestCountsTypeGuestCountItem) ? get_class($guestCountsTypeGuestCountItem) : sprintf('%s(%s)', gettype($guestCountsTypeGuestCountItem), var_export($guestCountsTypeGuestCountItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GuestCount property can only contain items of type \room\StructType\GuestCountType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GuestCount value
     * @throws \InvalidArgumentException
     * @param \room\StructType\GuestCountType[] $guestCount
     * @return \room\StructType\GuestCountsType
     */
    public function setGuestCount(array $guestCount = array())
    {
        // validation for constraint: array
        if ('' !== ($guestCountArrayErrorMessage = self::validateGuestCountForArrayConstraintsFromSetGuestCount($guestCount))) {
            throw new \InvalidArgumentException($guestCountArrayErrorMessage, __LINE__);
        }
        $this->GuestCount = $guestCount;
        return $this;
    }
    /**
     * Add item to GuestCount value
     * @throws \InvalidArgumentException
     * @param \room\StructType\GuestCountType $item
     * @return \room\StructType\GuestCountsType
     */
    public function addToGuestCount(\room\StructType\GuestCountType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \room\StructType\GuestCountType) {
            throw new \InvalidArgumentException(sprintf('The GuestCount property can only contain items of type \room\StructType\GuestCountType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GuestCount[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \room\StructType\GuestCountsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
