<?php

namespace room\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HotelRefType StructType
 * @subpackage Structs
 */
class HotelRefType extends AbstractStructBase
{
    /**
     * The Code
     * Meta information extracted from the WSDL
     * - use: required
     * @var string
     */
    public $Code;
    /**
     * The Name
     * @var string
     */
    public $Name;
    /**
     * The MarketSourceCode
     * @var string
     */
    public $MarketSourceCode;
    /**
     * Constructor method for HotelRefType
     * @uses HotelRefType::setCode()
     * @uses HotelRefType::setName()
     * @uses HotelRefType::setMarketSourceCode()
     * @param string $code
     * @param string $name
     * @param string $marketSourceCode
     */
    public function __construct($code = null, $name = null, $marketSourceCode = null)
    {
        $this
            ->setCode($code)
            ->setName($name)
            ->setMarketSourceCode($marketSourceCode);
    }
    /**
     * Get Code value
     * @return string
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param string $code
     * @return \room\StructType\HotelRefType
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        $this->Code = $code;
        return $this;
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \room\StructType\HotelRefType
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get MarketSourceCode value
     * @return string|null
     */
    public function getMarketSourceCode()
    {
        return $this->MarketSourceCode;
    }
    /**
     * Set MarketSourceCode value
     * @param string $marketSourceCode
     * @return \room\StructType\HotelRefType
     */
    public function setMarketSourceCode($marketSourceCode = null)
    {
        // validation for constraint: string
        if (!is_null($marketSourceCode) && !is_string($marketSourceCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($marketSourceCode, true), gettype($marketSourceCode)), __LINE__);
        }
        $this->MarketSourceCode = $marketSourceCode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \room\StructType\HotelRefType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
