<?php

namespace room\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ObmConfigsType StructType
 * @subpackage Structs
 */
class ObmConfigsType extends AbstractStructBase
{
    /**
     * The ObmConfig
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \room\StructType\ObmConfigType[]
     */
    public $ObmConfig;
    /**
     * Constructor method for ObmConfigsType
     * @uses ObmConfigsType::setObmConfig()
     * @param \room\StructType\ObmConfigType[] $obmConfig
     */
    public function __construct(array $obmConfig = array())
    {
        $this
            ->setObmConfig($obmConfig);
    }
    /**
     * Get ObmConfig value
     * @return \room\StructType\ObmConfigType[]|null
     */
    public function getObmConfig()
    {
        return $this->ObmConfig;
    }
    /**
     * This method is responsible for validating the values passed to the setObmConfig method
     * This method is willingly generated in order to preserve the one-line inline validation within the setObmConfig method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateObmConfigForArrayConstraintsFromSetObmConfig(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $obmConfigsTypeObmConfigItem) {
            // validation for constraint: itemType
            if (!$obmConfigsTypeObmConfigItem instanceof \room\StructType\ObmConfigType) {
                $invalidValues[] = is_object($obmConfigsTypeObmConfigItem) ? get_class($obmConfigsTypeObmConfigItem) : sprintf('%s(%s)', gettype($obmConfigsTypeObmConfigItem), var_export($obmConfigsTypeObmConfigItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ObmConfig property can only contain items of type \room\StructType\ObmConfigType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ObmConfig value
     * @throws \InvalidArgumentException
     * @param \room\StructType\ObmConfigType[] $obmConfig
     * @return \room\StructType\ObmConfigsType
     */
    public function setObmConfig(array $obmConfig = array())
    {
        // validation for constraint: array
        if ('' !== ($obmConfigArrayErrorMessage = self::validateObmConfigForArrayConstraintsFromSetObmConfig($obmConfig))) {
            throw new \InvalidArgumentException($obmConfigArrayErrorMessage, __LINE__);
        }
        $this->ObmConfig = $obmConfig;
        return $this;
    }
    /**
     * Add item to ObmConfig value
     * @throws \InvalidArgumentException
     * @param \room\StructType\ObmConfigType $item
     * @return \room\StructType\ObmConfigsType
     */
    public function addToObmConfig(\room\StructType\ObmConfigType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \room\StructType\ObmConfigType) {
            throw new \InvalidArgumentException(sprintf('The ObmConfig property can only contain items of type \room\StructType\ObmConfigType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ObmConfig[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \room\StructType\ObmConfigsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
