<?php

namespace room\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PostingModesType StructType
 * @subpackage Structs
 */
class PostingModesType extends AbstractStructBase
{
    /**
     * The PostingMode
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \room\StructType\PostingModeType[]
     */
    public $PostingMode;
    /**
     * Constructor method for PostingModesType
     * @uses PostingModesType::setPostingMode()
     * @param \room\StructType\PostingModeType[] $postingMode
     */
    public function __construct(array $postingMode = array())
    {
        $this
            ->setPostingMode($postingMode);
    }
    /**
     * Get PostingMode value
     * @return \room\StructType\PostingModeType[]|null
     */
    public function getPostingMode()
    {
        return $this->PostingMode;
    }
    /**
     * This method is responsible for validating the values passed to the setPostingMode method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPostingMode method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePostingModeForArrayConstraintsFromSetPostingMode(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $postingModesTypePostingModeItem) {
            // validation for constraint: itemType
            if (!$postingModesTypePostingModeItem instanceof \room\StructType\PostingModeType) {
                $invalidValues[] = is_object($postingModesTypePostingModeItem) ? get_class($postingModesTypePostingModeItem) : sprintf('%s(%s)', gettype($postingModesTypePostingModeItem), var_export($postingModesTypePostingModeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PostingMode property can only contain items of type \room\StructType\PostingModeType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PostingMode value
     * @throws \InvalidArgumentException
     * @param \room\StructType\PostingModeType[] $postingMode
     * @return \room\StructType\PostingModesType
     */
    public function setPostingMode(array $postingMode = array())
    {
        // validation for constraint: array
        if ('' !== ($postingModeArrayErrorMessage = self::validatePostingModeForArrayConstraintsFromSetPostingMode($postingMode))) {
            throw new \InvalidArgumentException($postingModeArrayErrorMessage, __LINE__);
        }
        $this->PostingMode = $postingMode;
        return $this;
    }
    /**
     * Add item to PostingMode value
     * @throws \InvalidArgumentException
     * @param \room\StructType\PostingModeType $item
     * @return \room\StructType\PostingModesType
     */
    public function addToPostingMode(\room\StructType\PostingModeType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \room\StructType\PostingModeType) {
            throw new \InvalidArgumentException(sprintf('The PostingMode property can only contain items of type \room\StructType\PostingModeType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PostingMode[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \room\StructType\PostingModesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
