<?php

namespace room\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RatePlansType StructType
 * @subpackage Structs
 */
class RatePlansType extends AbstractStructBase
{
    /**
     * The RatePlan
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \room\StructType\RatePlanType[]
     */
    public $RatePlan;
    /**
     * Constructor method for RatePlansType
     * @uses RatePlansType::setRatePlan()
     * @param \room\StructType\RatePlanType[] $ratePlan
     */
    public function __construct(array $ratePlan = array())
    {
        $this
            ->setRatePlan($ratePlan);
    }
    /**
     * Get RatePlan value
     * @return \room\StructType\RatePlanType[]|null
     */
    public function getRatePlan()
    {
        return $this->RatePlan;
    }
    /**
     * This method is responsible for validating the values passed to the setRatePlan method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRatePlan method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRatePlanForArrayConstraintsFromSetRatePlan(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $ratePlansTypeRatePlanItem) {
            // validation for constraint: itemType
            if (!$ratePlansTypeRatePlanItem instanceof \room\StructType\RatePlanType) {
                $invalidValues[] = is_object($ratePlansTypeRatePlanItem) ? get_class($ratePlansTypeRatePlanItem) : sprintf('%s(%s)', gettype($ratePlansTypeRatePlanItem), var_export($ratePlansTypeRatePlanItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RatePlan property can only contain items of type \room\StructType\RatePlanType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RatePlan value
     * @throws \InvalidArgumentException
     * @param \room\StructType\RatePlanType[] $ratePlan
     * @return \room\StructType\RatePlansType
     */
    public function setRatePlan(array $ratePlan = array())
    {
        // validation for constraint: array
        if ('' !== ($ratePlanArrayErrorMessage = self::validateRatePlanForArrayConstraintsFromSetRatePlan($ratePlan))) {
            throw new \InvalidArgumentException($ratePlanArrayErrorMessage, __LINE__);
        }
        $this->RatePlan = $ratePlan;
        return $this;
    }
    /**
     * Add item to RatePlan value
     * @throws \InvalidArgumentException
     * @param \room\StructType\RatePlanType $item
     * @return \room\StructType\RatePlansType
     */
    public function addToRatePlan(\room\StructType\RatePlanType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \room\StructType\RatePlanType) {
            throw new \InvalidArgumentException(sprintf('The RatePlan property can only contain items of type \room\StructType\RatePlanType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RatePlan[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \room\StructType\RatePlansType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
