<?php

namespace room\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ResDiaryReferencesType StructType
 * @subpackage Structs
 */
class ResDiaryReferencesType extends AbstractStructBase
{
    /**
     * The ResDiaryReference
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \room\StructType\ResDiaryReferenceType[]
     */
    public $ResDiaryReference;
    /**
     * Constructor method for ResDiaryReferencesType
     * @uses ResDiaryReferencesType::setResDiaryReference()
     * @param \room\StructType\ResDiaryReferenceType[] $resDiaryReference
     */
    public function __construct(array $resDiaryReference = array())
    {
        $this
            ->setResDiaryReference($resDiaryReference);
    }
    /**
     * Get ResDiaryReference value
     * @return \room\StructType\ResDiaryReferenceType[]|null
     */
    public function getResDiaryReference()
    {
        return $this->ResDiaryReference;
    }
    /**
     * This method is responsible for validating the values passed to the setResDiaryReference method
     * This method is willingly generated in order to preserve the one-line inline validation within the setResDiaryReference method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateResDiaryReferenceForArrayConstraintsFromSetResDiaryReference(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $resDiaryReferencesTypeResDiaryReferenceItem) {
            // validation for constraint: itemType
            if (!$resDiaryReferencesTypeResDiaryReferenceItem instanceof \room\StructType\ResDiaryReferenceType) {
                $invalidValues[] = is_object($resDiaryReferencesTypeResDiaryReferenceItem) ? get_class($resDiaryReferencesTypeResDiaryReferenceItem) : sprintf('%s(%s)', gettype($resDiaryReferencesTypeResDiaryReferenceItem), var_export($resDiaryReferencesTypeResDiaryReferenceItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ResDiaryReference property can only contain items of type \room\StructType\ResDiaryReferenceType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ResDiaryReference value
     * @throws \InvalidArgumentException
     * @param \room\StructType\ResDiaryReferenceType[] $resDiaryReference
     * @return \room\StructType\ResDiaryReferencesType
     */
    public function setResDiaryReference(array $resDiaryReference = array())
    {
        // validation for constraint: array
        if ('' !== ($resDiaryReferenceArrayErrorMessage = self::validateResDiaryReferenceForArrayConstraintsFromSetResDiaryReference($resDiaryReference))) {
            throw new \InvalidArgumentException($resDiaryReferenceArrayErrorMessage, __LINE__);
        }
        $this->ResDiaryReference = $resDiaryReference;
        return $this;
    }
    /**
     * Add item to ResDiaryReference value
     * @throws \InvalidArgumentException
     * @param \room\StructType\ResDiaryReferenceType $item
     * @return \room\StructType\ResDiaryReferencesType
     */
    public function addToResDiaryReference(\room\StructType\ResDiaryReferenceType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \room\StructType\ResDiaryReferenceType) {
            throw new \InvalidArgumentException(sprintf('The ResDiaryReference property can only contain items of type \room\StructType\ResDiaryReferenceType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ResDiaryReference[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \room\StructType\ResDiaryReferencesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
