<?php

namespace room\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RoomStaysType StructType
 * @subpackage Structs
 */
class RoomStaysType extends AbstractStructBase
{
    /**
     * The RoomStay
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * @var \room\StructType\RoomStayType[]
     */
    public $RoomStay;
    /**
     * Constructor method for RoomStaysType
     * @uses RoomStaysType::setRoomStay()
     * @param \room\StructType\RoomStayType[] $roomStay
     */
    public function __construct(array $roomStay = array())
    {
        $this
            ->setRoomStay($roomStay);
    }
    /**
     * Get RoomStay value
     * @return \room\StructType\RoomStayType[]|null
     */
    public function getRoomStay()
    {
        return $this->RoomStay;
    }
    /**
     * This method is responsible for validating the values passed to the setRoomStay method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRoomStay method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRoomStayForArrayConstraintsFromSetRoomStay(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $roomStaysTypeRoomStayItem) {
            // validation for constraint: itemType
            if (!$roomStaysTypeRoomStayItem instanceof \room\StructType\RoomStayType) {
                $invalidValues[] = is_object($roomStaysTypeRoomStayItem) ? get_class($roomStaysTypeRoomStayItem) : sprintf('%s(%s)', gettype($roomStaysTypeRoomStayItem), var_export($roomStaysTypeRoomStayItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RoomStay property can only contain items of type \room\StructType\RoomStayType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RoomStay value
     * @throws \InvalidArgumentException
     * @param \room\StructType\RoomStayType[] $roomStay
     * @return \room\StructType\RoomStaysType
     */
    public function setRoomStay(array $roomStay = array())
    {
        // validation for constraint: array
        if ('' !== ($roomStayArrayErrorMessage = self::validateRoomStayForArrayConstraintsFromSetRoomStay($roomStay))) {
            throw new \InvalidArgumentException($roomStayArrayErrorMessage, __LINE__);
        }
        $this->RoomStay = $roomStay;
        return $this;
    }
    /**
     * Add item to RoomStay value
     * @throws \InvalidArgumentException
     * @param \room\StructType\RoomStayType $item
     * @return \room\StructType\RoomStaysType
     */
    public function addToRoomStay(\room\StructType\RoomStayType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \room\StructType\RoomStayType) {
            throw new \InvalidArgumentException(sprintf('The RoomStay property can only contain items of type \room\StructType\RoomStayType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RoomStay[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \room\StructType\RoomStaysType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
