<?php

namespace room\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpsellsType StructType
 * @subpackage Structs
 */
class UpsellsType extends AbstractStructBase
{
    /**
     * The Upsell
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \room\StructType\UpsellType[]
     */
    public $Upsell;
    /**
     * Constructor method for UpsellsType
     * @uses UpsellsType::setUpsell()
     * @param \room\StructType\UpsellType[] $upsell
     */
    public function __construct(array $upsell = array())
    {
        $this
            ->setUpsell($upsell);
    }
    /**
     * Get Upsell value
     * @return \room\StructType\UpsellType[]|null
     */
    public function getUpsell()
    {
        return $this->Upsell;
    }
    /**
     * This method is responsible for validating the values passed to the setUpsell method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUpsell method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUpsellForArrayConstraintsFromSetUpsell(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $upsellsTypeUpsellItem) {
            // validation for constraint: itemType
            if (!$upsellsTypeUpsellItem instanceof \room\StructType\UpsellType) {
                $invalidValues[] = is_object($upsellsTypeUpsellItem) ? get_class($upsellsTypeUpsellItem) : sprintf('%s(%s)', gettype($upsellsTypeUpsellItem), var_export($upsellsTypeUpsellItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Upsell property can only contain items of type \room\StructType\UpsellType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Upsell value
     * @throws \InvalidArgumentException
     * @param \room\StructType\UpsellType[] $upsell
     * @return \room\StructType\UpsellsType
     */
    public function setUpsell(array $upsell = array())
    {
        // validation for constraint: array
        if ('' !== ($upsellArrayErrorMessage = self::validateUpsellForArrayConstraintsFromSetUpsell($upsell))) {
            throw new \InvalidArgumentException($upsellArrayErrorMessage, __LINE__);
        }
        $this->Upsell = $upsell;
        return $this;
    }
    /**
     * Add item to Upsell value
     * @throws \InvalidArgumentException
     * @param \room\StructType\UpsellType $item
     * @return \room\StructType\UpsellsType
     */
    public function addToUpsell(\room\StructType\UpsellType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \room\StructType\UpsellType) {
            throw new \InvalidArgumentException(sprintf('The Upsell property can only contain items of type \room\StructType\UpsellType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Upsell[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \room\StructType\UpsellsType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
