<?php

namespace room\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for WholeStayDiscountsLosRulesType StructType
 * @subpackage Structs
 */
class WholeStayDiscountsLosRulesType extends AbstractStructBase
{
    /**
     * The WholeStayDiscountsLosRule
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \room\StructType\WholeStayDiscountsLosRuleType[]
     */
    public $WholeStayDiscountsLosRule;
    /**
     * Constructor method for WholeStayDiscountsLosRulesType
     * @uses WholeStayDiscountsLosRulesType::setWholeStayDiscountsLosRule()
     * @param \room\StructType\WholeStayDiscountsLosRuleType[] $wholeStayDiscountsLosRule
     */
    public function __construct(array $wholeStayDiscountsLosRule = array())
    {
        $this
            ->setWholeStayDiscountsLosRule($wholeStayDiscountsLosRule);
    }
    /**
     * Get WholeStayDiscountsLosRule value
     * @return \room\StructType\WholeStayDiscountsLosRuleType[]|null
     */
    public function getWholeStayDiscountsLosRule()
    {
        return $this->WholeStayDiscountsLosRule;
    }
    /**
     * This method is responsible for validating the values passed to the setWholeStayDiscountsLosRule method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWholeStayDiscountsLosRule method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWholeStayDiscountsLosRuleForArrayConstraintsFromSetWholeStayDiscountsLosRule(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $wholeStayDiscountsLosRulesTypeWholeStayDiscountsLosRuleItem) {
            // validation for constraint: itemType
            if (!$wholeStayDiscountsLosRulesTypeWholeStayDiscountsLosRuleItem instanceof \room\StructType\WholeStayDiscountsLosRuleType) {
                $invalidValues[] = is_object($wholeStayDiscountsLosRulesTypeWholeStayDiscountsLosRuleItem) ? get_class($wholeStayDiscountsLosRulesTypeWholeStayDiscountsLosRuleItem) : sprintf('%s(%s)', gettype($wholeStayDiscountsLosRulesTypeWholeStayDiscountsLosRuleItem), var_export($wholeStayDiscountsLosRulesTypeWholeStayDiscountsLosRuleItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WholeStayDiscountsLosRule property can only contain items of type \room\StructType\WholeStayDiscountsLosRuleType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WholeStayDiscountsLosRule value
     * @throws \InvalidArgumentException
     * @param \room\StructType\WholeStayDiscountsLosRuleType[] $wholeStayDiscountsLosRule
     * @return \room\StructType\WholeStayDiscountsLosRulesType
     */
    public function setWholeStayDiscountsLosRule(array $wholeStayDiscountsLosRule = array())
    {
        // validation for constraint: array
        if ('' !== ($wholeStayDiscountsLosRuleArrayErrorMessage = self::validateWholeStayDiscountsLosRuleForArrayConstraintsFromSetWholeStayDiscountsLosRule($wholeStayDiscountsLosRule))) {
            throw new \InvalidArgumentException($wholeStayDiscountsLosRuleArrayErrorMessage, __LINE__);
        }
        $this->WholeStayDiscountsLosRule = $wholeStayDiscountsLosRule;
        return $this;
    }
    /**
     * Add item to WholeStayDiscountsLosRule value
     * @throws \InvalidArgumentException
     * @param \room\StructType\WholeStayDiscountsLosRuleType $item
     * @return \room\StructType\WholeStayDiscountsLosRulesType
     */
    public function addToWholeStayDiscountsLosRule(\room\StructType\WholeStayDiscountsLosRuleType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \room\StructType\WholeStayDiscountsLosRuleType) {
            throw new \InvalidArgumentException(sprintf('The WholeStayDiscountsLosRule property can only contain items of type \room\StructType\WholeStayDiscountsLosRuleType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WholeStayDiscountsLosRule[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \room\StructType\WholeStayDiscountsLosRulesType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
